package dev.shadowsoffire.apotheosis.adventure.client;

import java.util.List;
import net.minecraft.client.Minecraft;
import java.util.ArrayList;
import net.minecraft.ChatFormatting;
import com.mojang.blaze3d.systems.RenderSystem;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.client.gui.components.Button;

public class SimpleTexButton extends Button
{
    protected final ResourceLocation texture;
    protected final int xTexStart;
    protected final int yTexStart;
    protected final int textureWidth;
    protected final int textureHeight;
    protected Component inactiveMessage;
    
    public SimpleTexButton(final int pX, final int pY, final int pWidth, final int pHeight, final int pXTexStart, final int pYTexStart, final ResourceLocation texture, final Button.OnPress pOnPress) {
        this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, 256, 256, pOnPress);
    }
    
    public SimpleTexButton(final int pX, final int pY, final int pWidth, final int pHeight, final int pXTexStart, final int pYTexStart, final ResourceLocation texture, final int pTextureWidth, final int pTextureHeight, final Button.OnPress pOnPress) {
        this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, pTextureWidth, pTextureHeight, pOnPress, CommonComponents.f_237098_);
    }
    
    public SimpleTexButton(final int pX, final int pY, final int pWidth, final int pHeight, final int pXTexStart, final int pYTexStart, final ResourceLocation texture, final int pTextureWidth, final int pTextureHeight, final Button.OnPress pOnPress, final Component pMessage) {
        this(pX, pY, pWidth, pHeight, pXTexStart, pYTexStart, texture, pTextureWidth, pTextureHeight, pOnPress, SimpleTexButton.f_252438_, pMessage);
    }
    
    public SimpleTexButton(final int pX, final int pY, final int pWidth, final int pHeight, final int pXTexStart, final int pYTexStart, final ResourceLocation texture, final int pTextureWidth, final int pTextureHeight, final Button.OnPress pOnPress, final Button.CreateNarration pOnTooltip, final Component pMessage) {
        super(pX, pY, pWidth, pHeight, pMessage, pOnPress, pOnTooltip);
        this.inactiveMessage = CommonComponents.f_237098_;
        this.textureWidth = pTextureWidth;
        this.textureHeight = pTextureHeight;
        this.xTexStart = pXTexStart;
        this.yTexStart = pYTexStart;
        this.texture = texture;
    }
    
    public SimpleTexButton setInactiveMessage(final Component msg) {
        this.inactiveMessage = msg;
        return this;
    }
    
    public void m_264152_(final int pX, final int pY) {
        this.m_252865_(pX);
        this.m_253211_(pY);
    }
    
    public void m_87963_(final GuiGraphics gfx, final int pMouseX, final int pMouseY, final float pPartialTick) {
        int yTex = this.yTexStart;
        if (!this.m_142518_()) {
            yTex += this.f_93619_;
        }
        else if (this.m_274382_()) {
            yTex += this.f_93619_ * 2;
        }
        RenderSystem.enableDepthTest();
        gfx.m_280163_(this.texture, this.m_252754_(), this.m_252907_(), (float)this.xTexStart, (float)yTex, this.f_93618_, this.f_93619_, this.textureWidth, this.textureHeight);
        if (this.m_274382_()) {
            this.renderToolTip(gfx, pMouseX, pMouseY);
        }
    }
    
    public void renderToolTip(final GuiGraphics gfx, final int pMouseX, final int pMouseY) {
        if (this.m_6035_() != CommonComponents.f_237098_ && this.m_274382_()) {
            Component primary = this.m_6035_();
            if (!this.f_93623_) {
                primary = (Component)primary.m_6881_().m_130940_(ChatFormatting.GRAY);
            }
            final List<Component> tooltips = new ArrayList<Component>();
            tooltips.add(primary);
            if (!this.f_93623_ && this.inactiveMessage != CommonComponents.f_237098_) {
                tooltips.add(this.inactiveMessage);
            }
            gfx.m_280666_(Minecraft.m_91087_().f_91062_, (List)tooltips, pMouseX, pMouseY);
        }
    }
}
